<?php

/***************************************************************************
 *
 * listavatars.php
 * http://www.1-4a.com
 *
 * Demo:
 * http://www.in-my-opinion.org/listavatars.php
 *
 ***************************************************************************/
 
define('IN_PHPBB', true);
$filename = basename(__FILE__);

if (!empty($setmodules))
	{
	$module['Misc']['List_All_Avatars'] = $filename;
	return;
	}

$phpbb_root_path = './'; // Normal use
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

$maxavatarperuser = 50000; // Max avatars (as bytes) we will show PER USER?
$maxavatarperpage = 5000000; // Max avatars (as bytes) we will show PER PAGE?
$startfromuser = intval($HTTP_GET_VARS['startfromuser']);
$showonlyuserid = intval($HTTP_GET_VARS['showonlyuserid']);


$lang_file = $phpbb_root_path.'language/lang_'.$board_config['default_lang'].'/lang_listavatars.'.$phpEx;
if (!@file_exists($lang_file)) 
	{
	$lang_file = $phpbb_root_path.'language/lang_english/lang_listavatars.'.$phpEx; // load English version if there is no translation to current language
	}
include($lang_file);

function addavatar($user_id,$avatar,$typ,$avatars,$counter)
	{
	global $board_config,$lang,$phpbb_root_path,$sumofavatarsizesofuser,$sumofallavatars,$notshownavatarsofuser,$maxavatarperuser,$showonlyuserid;
	
	if ($avatar == '')
		{
		return  $avatars;
		}
	
	switch ($typ)
		{
		CASE 1: $avatar = $phpbb_root_path.$board_config['avatar_path'].'/'.$avatar; // Uploaded Avatar
			break; 
		CASE 2: $avatar = $avatar; // Avatar on other server
			break; 
		CASE 3: $avatar = $phpbb_root_path.$board_config['avatar_gallery_path'].'/'.$avatar; // Avatar from the Forum's Avatar Gallery
			break; 
		}
	
	if (strpos($avatars,'"'.$avatar.'"') > 0)  // Avatar already there
		{
		return $avatars;
		}
	else // Avatar not there yet -> Add it
		{
		switch ($typ)
			{
			CASE 1:
			CASE 3: $avatarsize = @filesize($avatar);
				break; 
			CASE 2: $avatarsize = 20000; // Avatar on other server -> Assume it's 20 KB big
				break; 
			}
		if (($showonlyuserid == 0) && ($sumofavatarsizesofuser[$user_id] > 0) && ($avatarsize+$sumofavatarsizesofuser[$user_id] > $maxavatarperuser)) // Show max 200KB of avatars per single user
			{ // Don't add this avatar, since more than max allowed bytes would be shown
			$notshownavatarsofuser[$user_id]++;
			return $avatars;
			}
		$sumofavatarsizesofuser[$user_id] += $avatarsize;
		$sumofallavatars += $avatarsize;
		$avatar = '"'.$avatar.'"';
		if (preg_match('/[.](jpg|jpeg)"$/i',$avatar,$matches)) // is a jpg
			{
			$borderstyle = 'style="border:1px solid black;"'; // Looks better
			}
		else
			{
			$borderstyle = 'style="border:0px"';
			}
		return  $avatars.'<img src='.$avatar.' '.$borderstyle.' title="'.$counter.'"> ';
		}
	}

$sqlu=	 ' SELECT	DISTINCT u.user_id, u.username, user_posts, u.user_avatar, u.user_avatar_type ' // Get all users who have posted at least 1 post
	.' FROM '.USERS_TABLE.' u, '.POSTS_TABLE.' p '
	.' WHERE		u.user_id <> '.ANONYMOUS
	.'	and	u.user_id = p.poster_id '
	.($showonlyuserid ? ' and u.user_id = '.$showonlyuserid : '')
	.' ORDER BY u.user_posts DESC '
	.'';
	
$resultuser = $db->sql_query($sqlu);

$i = 0;
$tdclass = 1;
$sumofavatarsizesofuser = array();
$notshownavatarsofuser = array();
$sumofallavatars = 0;
$continue = '';


while (($user = $db->sql_fetchrow($resultuser)) ) // Cycle thru all users
	{
	$i++;
	if ($i < $startfromuser) // Users have been already listed on the last page
		{
		continue;
		}
		
	if (($sumofallavatars > $maxavatarperpage) && ($showonlyuserid == 0))
		{
		if (!$continue)
			{
			$continue = '<a href="'.$filename.'?startfromuser='.($i).'">'.$lang['listavatars_seemoreusers'].'</a>';
			}
		continue;
		}
	
	$avatars = '';
	$sql=	' SELECT	p.user_avatar, p.user_avatar_type, COUNT(p.user_avatar) as postcount, MIN(p.post_time) as ptime '.   // Get all avatars for this user
		' FROM	'.POSTS_TABLE.' p '.
		' where 	p.poster_id = '.$user['user_id'].' '.
		' GROUP BY p.user_avatar '.
		' ORDER BY ptime DESC ';
	
	
	if ($result = $db->sql_query($sql)) // Sticky Avatar Mod installed
		{
		while (($row = $db->sql_fetchrow($result)) ) // Cycle thru each Avatar
			{
			if ($row['user_avatar'] == '') // No Avatar used for these posts -> Use standard user avatar
				{
				$avatars = addavatar($user['user_id'],$user['user_avatar'],$user['user_avatar_type'],$avatars,$row['postcount'].' '.$lang['listavatars_timesused']);
				}
			else // Sticky Avatar used for these posts
				{
				$avatars = addavatar($user['user_id'],$row['user_avatar'],$row['user_avatar_type'],$avatars,$row['postcount'].' '.$lang['listavatars_timesused']);
				}
			
			}
		$avatars = addavatar($user['user_id'],$user['user_avatar'],$user['user_avatar_type'],$avatars,$lang['listavatars_unusedstandardavatar']); // Standard Avatar -> Will be added if the above loop hasn't added it yet
		}
	else // No sticky mod installed =  normal
		{
		$avatars = addavatar($user['user_id'],$user['user_avatar'],$user['user_avatar_type'],$avatars,$user['user_posts'].' '.$lang['listavatars_timesused']); // Standard Avatar -> Will be added 
		}
		
	if ($notshownavatarsofuser[$user['user_id']]) // There are more avatars of this user
		{
		$avatars .= '<br />'.'<a href="'.$filename.'?showonlyuserid='.$user['user_id'].'">'.sprintf($lang['listavatars_seemoreavatars'],$notshownavatarsofuser[$user['user_id']],($notshownavatarsofuser[$user['user_id']] > 1 ? 's' : '')).'</a>';
		}
	
	if ($avatars != '') // Display user, if the user has at least 1 avatar to show
		{
		$tdclass++;
		$template->assign_block_vars('avatarblock', array(
			'USERNAME' => $user['username'],
			'USERNAMELINK' => append_sid($phpbb_root_path.'profile.'.$phpEx.'?mode=viewprofile&amp;u='.$user['user_id']),
			'ROW_CLASS' => ( !($tdclass % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
			'AVATARS' => $avatars
			)
			);
		}
	}

if ($showonlyuserid)
	{
	$continue = '<a href="'.$filename.'">'.$lang['listavatars_showall'].'</a>';
	}

$template->assign_vars(array( // General variables
	'SHOWMORE' => $continue
	)
	);

// Start output of page
$page_title = $lang['listavatars_title'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'listavatars' => 'listavatars.tpl')
	);

$template->pparse('listavatars');
echo '<br /><br /><span class="gensmall" style="text-align:right; width:100%"><a href="http://www.1-4a.com">Listavatars phpBB Mod by 1-4a.com</a></span>';
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>